"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MySqlService = void 0;
const common_1 = require("@nestjs/common");
const mysql_constants_1 = require("./mysql.constants");
let MySqlService = class MySqlService {
    constructor(options) {
        this.options = options;
    }
    async onApplicationBootstrap() {
        await this.connect();
    }
    async connect() {
        const mysql = require("mysql2/promise");
        this.connection = await mysql.createConnection(this.options);
    }
    async exec(query) {
        if (!this.connection) {
            await this.connect();
        }
        const [rows] = await this.connection.query(query);
        return rows;
    }
    async execSingle(query) {
        const rows = await this.exec(query);
        return rows[0];
    }
};
MySqlService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(mysql_constants_1.MysqlConstants.MYSQL_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], MySqlService);
exports.MySqlService = MySqlService;
